%%    "   "
%      No2
% :            - ABC, 120, 0, dq0
clear, clc, format compact, format short

%% 
%          
deg2rad = pi/180;
rad2deg = 180/pi;
dt = 0.00005;
tn = 0; % [s],    
j  = sqrt(-1);
q2 = sqrt(2);
q3 = sqrt(3);

% 
fm_base = 50; % [Hz],   
fdq_base = 50; % [Hz],   dq 
g0g = 0; % [],     d          
tk  = 0.06; % [s],   

W0 = 2*pi*fm_base; % [rad/s],    
g0 = g0g*deg2rad; % [rad],     d          

%     ( )
% Ubase = [ q2*110.00/q3*sin(W0*t);
%           q2*110.00/q3*sin(W0*t-120*deg2rad);
%           q2*110.00/q3*sin(W0*t+120*deg2rad)];
% 
% Ibase = [ 10.00*exp(-t/0.05);
%           -5.00*exp(-t/0.05);
%           -5.00*exp(-t/0.05)];

%% 4)     dq  (  gama0)
fprintf('\n### 1 / . 4 )\n');
correctInput = false;
while not(correctInput)
    Kf = input('#  Kf = ');
    if not(isempty(Kf)) && isreal(Kf)
        correctInput = true;
    else
        fprintf(' Kf     ! \n');
    end
end

fdq = fdq_base * [1; Kf; 10*Kf];

for ind = 1:3
    Wdq=2*pi*fdq(ind);
    %      t
    L=1; Lk=ceil((tk-tn)/dt)+2;
    P=0; T=0; U=0; Up=0; UT=0; UTp=0; t  = tn;
    fprintf('\nt = %8.5f s', t);
    while (Lk-L),
        fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\bt = %8.5f s', t);
        g=Wdq*t + g0;
        
        %        ABC  dg0
        Park =(2/3)* [ cos(g)   cos(g-120*deg2rad)   cos(g+120*deg2rad);
                       sin(g)   sin(g-120*deg2rad)   sin(g+120*deg2rad);
                       1/2      1/2             1/2];
        
        U = [ q2*110.00/q3*sin(W0*t);
            q2*110.00/q3*sin(W0*t-120*deg2rad);
            q2*110.00/q3*sin(W0*t+120*deg2rad)];
        
        I = [ 10.00*exp(-t/0.05);
            -5.00*exp(-t/0.05);
            -8.00*exp(-t/0.05)];
        
        T(L,1)=t;
        U_m_abc(L,1:3) = U'; %     
        I_m_abc(L,1:3) = I'; %     
        Up = Park*U;
        Ip = Park*I;
        for k=1:3,
            if abs(Up(k,1))<1e-9,
                Up(k,1)=0;
            end
            if abs(Ip(k,1))<1e-9,
                Ip(k,1)=0;
            end
        end
        U_m_dq0(L,1:3) = Up'; %    dq 
        I_m_dq0(L,1:3) = Ip'; %    dq 
        t = t+dt;
        L = L+1;
    end
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b');
    
    % 
    figure('NumberTitle', 'off', ...
        'Name', sprintf('      dq0 .  gama = %5.2f   fdq = %5.2f Hz',g0g,fdq(ind)));
    % 
    subplot(2,2,1);
    plot(T,U_m_abc(:,1),'-',T,U_m_abc(:,2),'--',T,U_m_abc(:,3),'-.');
%     title(sprintf('\n '));
    ylabel('U, [kV]'); xlabel(sprintf('t, [s]'));
    grid on; legend(' A', ' B', ' C');
    
    subplot(2,2,3);
    plot(T,U_m_dq0(:,1),'-',T,U_m_dq0(:,2),'--',T,U_m_dq0(:,3),'-.');
%     title(sprintf('dq0 '));
    ylabel('U, [kV]'); xlabel('t, [s]');
    grid on; legend(' d', ' q', ' 0');
    
    % 
    subplot(2,2,2);
    plot(T,I_m_abc(:,1),'-',T,I_m_abc(:,2),'--',T,I_m_abc(:,3),'-.');
%     title(sprintf('\n '));
    ylabel('I, [kA]'); xlabel(sprintf('t, [s]'));
    grid on; legend(' A', ' B', ' C');
    
    subplot(2,2,4);
    plot(T,I_m_dq0(:,1),'-',T,I_m_dq0(:,2),'--',T,I_m_dq0(:,3),'-.');
%     title(sprintf('dq0 '));
    ylabel('I, [kA]'); xlabel('t, [s]');
    grid on; legend(' d', ' q', ' 0');
    
    fprintf('\n#   gama = %5.2f   fdq = %5.2f Hz',g0g,fdq(ind));
    fprintf('\n  UA_max = %5.2f kV;', max(U_m_abc(:,1)));
    fprintf('\n  UB_max = %5.2f kV;', max(U_m_abc(:,2)));
    fprintf('\n  UC_max = %5.2f kV;\n', max(U_m_abc(:,3)));
    
    fprintf('\n  Ud_max = %5.2f kV;', max(U_m_dq0(:,1)));
    fprintf('\n  Uq_max = %5.2f kV;', max(U_m_dq0(:,2)));
    fprintf('\n  U0_max = %5.2f kV;\n', max(U_m_dq0(:,3)));

    fprintf('\n(       )');
    pause;
    fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);
end

%% 4)   gama0 ( a   dq )
fprintf('\n### 1 / . 4 )\n');
correctInput = false;
while not(correctInput)
    Kgama = input('#  Kgama = ');
    if not(isempty(Kgama)) && isreal(Kgama)
        correctInput = true;
    else
        fprintf(' Kgama     ! \n');
    end
end

fdq = fdq_base;
g0  = [10; 45; 90]*deg2rad * Kgama;

for ind = 1:3
    Wdq=2*pi*fdq;
    %      t
    L=1; Lk=ceil((tk-tn)/dt)+2;
    P=0; T=0; U=0; Up=0; UT=0; UTp=0; t  = tn;
    fprintf('\nt = %8.5f s', t);
    while (Lk-L),
        fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\bt = %8.5f s', t);
        g=Wdq*t + g0(ind);
        
        %        ABC  dg0
        Park =(2/3)* [ cos(g)   cos(g-120*deg2rad)   cos(g+120*deg2rad);
                       sin(g)   sin(g-120*deg2rad)   sin(g+120*deg2rad);
                       1/2      1/2             1/2];
        
        U = [ q2*110.00/q3*sin(W0*t);
            q2*110.00/q3*sin(W0*t-120*deg2rad);
            q2*110.00/q3*sin(W0*t+120*deg2rad)];
        
        I = [ 10.00*exp(-t/0.05);
            -5.00*exp(-t/0.05);
            -8.00*exp(-t/0.05)];
        
        T(L,1)=t;
        U_m_abc(L,1:3) = U'; %     
        I_m_abc(L,1:3) = I'; %     
        Up = Park*U;
        Ip = Park*I;
        for k=1:3,
            if abs(Up(k,1))<1e-9,
                Up(k,1)=0;
            end
            if abs(Ip(k,1))<1e-9,
                Ip(k,1)=0;
            end
        end
        U_m_dq0(L,1:3) = Up'; %    dq 
        I_m_dq0(L,1:3) = Ip'; %    dq 
        t = t+dt;
        L = L+1;
    end
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b');
    
    % 
    figure('NumberTitle', 'off', ...
        'Name', sprintf('      dq0 .  gama = %5.2f   fdq = %5.2f Hz',g0(ind)*rad2deg, fdq));
    % 
    subplot(2,2,1);
    plot(T,U_m_abc(:,1),'-',T,U_m_abc(:,2),'--',T,U_m_abc(:,3),'-.');
%     title(sprintf('\n '));
    ylabel('U, [kV]'); xlabel(sprintf('t, [s]'));
    grid on; legend(' A', ' B', ' C');
    
    subplot(2,2,3);
    plot(T,U_m_dq0(:,1),'-',T,U_m_dq0(:,2),'--',T,U_m_dq0(:,3),'-.');
%     title(sprintf('dq0 '));
    ylabel('U, [kV]'); xlabel('t, [s]');
    grid on; legend(' d', ' q', ' 0');
    
    % 
    subplot(2,2,2);
    plot(T,I_m_abc(:,1),'-',T,I_m_abc(:,2),'--',T,I_m_abc(:,3),'-.');
%     title(sprintf('\n '));
    ylabel('I, [kA]'); xlabel(sprintf('t, [s]'));
    grid on; legend(' A', ' B', ' C');
    
    subplot(2,2,4);
    plot(T,I_m_dq0(:,1),'-',T,I_m_dq0(:,2),'--',T,I_m_dq0(:,3),'-.');
%     title(sprintf('dq0 '));
    ylabel('I, [kA]'); xlabel('t, [s]');
    grid on; legend(' d', ' q', ' 0');
    
    fprintf('\n#   gama = %5.2f   fdq = %5.2f Hz',g0(ind)*rad2deg, fdq);
    fprintf('\n  UA_max = %5.2f kV;', max(U_m_abc(:,1)));
    fprintf('\n  UB_max = %5.2f kV;', max(U_m_abc(:,2)));
    fprintf('\n  UC_max = %5.2f kV;\n', max(U_m_abc(:,3)));
    
    fprintf('\n  Ud_max = %5.2f kV;', max(U_m_dq0(:,1)));
    fprintf('\n  Uq_max = %5.2f kV;', max(U_m_dq0(:,2)));
    fprintf('\n  U0_max = %5.2f kV;\n', max(U_m_dq0(:,3)));

    fprintf('\n(       )');
    pause;
    fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);
end

%% 
fprintf('\n#   %s\n',mfilename );
